<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Report_views_weekly_model extends CI_Model
{
    protected $_table='report_views_weekly';

    public function __construct(){
        parent::__construct();
        date_default_timezone_set("Asia/Ho_Chi_Minh");
    }

    public function cmsCountAll($name = null)
    {
        $this->db->select('COUNT(*) AS totalResults');
        $this->db->from($this->_table);
        // if ($name != null) {
        //     $this->db->like('title', $name, 'both');
        //     $this->db->or_like('description', $name, 'both');
        //     $this->db->or_like('slug', $name, 'both');
        //     $this->db->or_like('tag', $name, 'both');
        // }
        $query = $this->db->get();
        $result = $query->result_array();
        if ($result) {
            return $result[0]['totalResults'];
        } else {
            return 0;
        }
    }

    public function cmsGetPagination($record, $start, $name = null)
    {
        $this->db->select($this->_table . '.*, u1.full_name AS singer_name, track_user.name AS singer_name2,
        tracks.title AS name_song, GROUP_CONCAT(track_user.`name` SEPARATOR ",") AS all_name, tracks.art AS art');
        $this->db->from($this->_table);
        $this->db->join('track_user', 'track_user.track_id = report_views_weekly.track_id', 'left');
        $this->db->join('tracks', 'tracks.id = report_views_weekly.track_id', 'left');
        $this->db->join('users u1', 'u1.id = track_user.user_id', 'left');
        if ($name != null) {
            $data = explode('-', $name);  
            $this->db->where('week', $data[0]);
            $this->db->where('year', $data[1]);
        }
        $this->db->group_by('report_views_weekly.id');
        $this->db->order_by($this->_table . '.total_point', 'desc');
        $this->db->limit($record);
        $query = $this->db->get();

        return $query->result_array();
    }
    public function selectSearch() {
        $this->db->select('week, year');
        $this->db->from($this->_table);
        $this->db->distinct($this->_table . '.week');
        $this->db->order_by( $this->_table . '.year desc');
        $this->db->order_by( $this->_table . '.week desc');
        $this->db->limit(15);
        $query = $this->db->get();

        return $query->result_array();
    }

}